package com.shcd.ghjg_pdf.service.impl;

import com.itextpdf.text.DocumentException;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfStamper;
import com.itextpdf.text.pdf.PdfWriter;
import java.awt.Color;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.pdmodel.PDPage;
import org.apache.pdfbox.pdmodel.PDPageContentStream;
import org.apache.pdfbox.pdmodel.font.PDType1Font;
import org.apache.pdfbox.util.Matrix;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Date;

@Component
public class PDFServicePDFBOXImpl {
//    @PostConstruct
    public void PDFEncode() throws IOException, DocumentException {
        int rowSpace=150;
        int colSpace=200;
        Date date = new Date();
        int year = date.getYear() + 1900;
        int month = date.getMonth() + 1;
        int day = date.getDay();
        PDDocument load = PDDocument.load(new File("E:\\DataShareFolder\\shipDrawArchive\\SMU749-050-09JS完整稳性计算报告.pdf"));
        for (int i = 0; i < load.getNumberOfPages(); i++) {
            PDPageContentStream contentStream = new PDPageContentStream(load, load.getPage(i), PDPageContentStream.AppendMode.APPEND, true, true);
            // 设置字体和字号
            contentStream.setFont(PDType1Font.HELVETICA_BOLD, 36);
            //设置透明度
            contentStream.setNonStrokingColor(new Color(200, 200, 200));
            //添加水印
            contentStream.beginText();
            PDPage page = load.getPage(i);
            float pageHeight = page.getMediaBox().getHeight();
            float pageWidth = page.getMediaBox().getWidth();
            //pdf修改水印
            for (int h = 10; h < pageHeight; h = h + rowSpace) {
                for (int w = - 10; w < pageWidth; w = w + colSpace) {
                    contentStream.setTextMatrix(Matrix.getRotateInstance(0.3, w, h));
                    contentStream.showText(year + "-" + month + "-" + day);
                }
            }
            //contentStream.newLineAtOffset(100, 100);

//            contentStream.showText();
            contentStream.endText();
            contentStream.close();
        }
        load.save("E:\\DataShareFolder\\pdf\\SMU749-050-09JS完整稳性计算报告水印版.pdf");
        load.close();
//        PdfReader reader = new PdfReader("E:\\pdf\\SMU749-050-09JS完整稳性计算报告水印版.pdf");
//        PdfStamper stamper = new PdfStamper(reader, Files.newOutputStream(Paths.get("E:\\pdf\\SMU749-050-09JS完整稳性计算报告水印密码版.pdf")));
//        stamper.setEncryption("123456".getBytes(), "12345".getBytes(), PdfWriter.ALLOW_PRINTING, PdfWriter.STANDARD_ENCRYPTION_40);
//        stamper.flush();
//        stamper.close();
//        reader.close();
    }
}
